var mongoose = require('mongoose');
var express = require('express.io');
var path = require('path');
var mqtt    = require('mqtt');
var util    = require('util');
//var client  = mqtt.connect('tcp://iot.eclipse.org');
var client  = mqtt.connect('tcp://192.168.21.117:1883');

var url = 'mongodb://localhost:27017/test';

var app = express();

app.configure(function(){
  app.use(express.bodyParser());
  app.use(express.static(path.join(__dirname, 'public')));
});

mongoose.connect(url);
var db = mongoose.connection;
db.on('error', function () {
  throw new Error('unable to connect to database at ' + url);
});

require('./models/Result');
Result = mongoose.model('Result');

db.on('connected', function(){
	var server = app.listen(8080, function () {
  		var host = server.address().address;
  		var port = server.address().port;
  		console.log('Example app listening at http://%s:%s', host, port);
	});
});
client.on('connect', function () {
  client.subscribe('private/solar/#');
  console.log("connected to mqtt...");
});
global.panelData;
global.messageTopic;
global.panelCode;
global.dataIndex = -0.5;
client.on('message', function (topic, message) {
	if(global.panelCode != null && (topic.indexOf(global.panelCode) > -1)){
		console.log("global.panelCode :: " +global.panelCode + ":: topic :: "+topic);
		global.panelData = JSON.parse(message);
		global.messageTopic = topic;
	}
});

app.get('/getPanelData', function (req,res) {
	if(global.panelCode == null || global.panelCode != req.query.panelId){
		global.panelCode = req.query.panelId;
	}
	console.log("requesting panel data..."+panelCode);
	var panelVoltage = -1;
	if(global.messageTopic != null){
		console.log("power ::: "+global.panelData.panelvoltage);
		console.log("topic :: " + util.inspect(global.messageTopic));
		if(global.messageTopic != null && (global.messageTopic.indexOf(panelCode) > -1)){
			console.log("success");
			panelVoltage = global.panelData.panelvoltage;
		}
	}
	global.dataIndex += 0.5;
    res.send(global.dataIndex +','+ panelVoltage);
});
